/*
 * *****************************************************************
 * *                                                               *
 * *       Copyright (c) Fast Corporation, 1998                    *
 * *                                                               *
 * *   All Rights Reserved.  Unpublished rights  reserved  under   *
 * *   the copyright laws of the Japan.                            *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Fast      *
 * *   Corporation.  Possession, use,  duplication  or             *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Fast Corporation.  *
 * *                                                               *
 * *****************************************************************
 */

/* brbXOw@qrQRQbʐMTvvO */
/* 				 		   lr|cnrPUrbgp */
/* 		C[`  C_RCMDGS.C */
/*m쐬ҁnA.Kameda */
/*
ړIF	XOwVXeR}hɂOCT[`s܂B
֐F	
F	Ver 1.00	97/11/05
		Ver 2.00	98/11/09	Watcomm C/C++ ΉB
LF	XOw̃GR[obN[on]A^[~l[g[CR/LF]ƂB
		g
 		c_rcmdgs [option [option...]]
 		-Mn zXg̋@ԍłB
			n 0(PC9801), 1(IBMPC), 2(J3100), 3(AX) ȗ0 łB
		-Bn	{[[głB
	  		n 1200, 1800, 2400, 4800, 9600, 19200 ȗ9600 łB
		-Ln	f[^łB
	  		n 5, 6, 7, 8 ȗ8 łB
		-Pn	peBłB
  			n 0(NONE), 1(ODD), 3(EVEN) ȗ0 łB
		-Sn	XgbvrbgłB
	  		n 0(1bits), 1(1.5bits), 3(2bits) ȗ0 łB
        -?  g\܂B
        
		Copyright (c) 1997, FAST Corporation
*/


/*
 * Include compiler runtime library
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <process.h>
#include <ctype.h>
#include <conio.h>


/*
 * Include CSC90X library
 */
#include "clink.h"			/* qrQRQbCb|khmjCu */


#define		RETRY_TIME		10
#define 	ON				1
#define 	OFF				0
#define		CR_OK			0
#define		CR_ERR			1
#define		CR_NAK			2
#define		CR_NON			3


/*
 * vg^Cv錾
 */
static short	rs232c_gs_cmd( void );
static short	rs232c_gs_next( void );
static void		get_infdata( unsigned char [], unsigned char [], unsigned char [], unsigned char [] );
static void		rs232c_clear_cmd( void );
static void		rs232c_err_message( short );
static void 	illegal_option( void );


/*
 * C
 */
void main( int argc, char **argv )
{
	short machine, speed, length, parities, stops, xs, channel;
	short ret, exit_value;
	
#ifdef __WATCOMC__
	cprintf( "\r\nRS232C Sample programyC_RCMDGS.EXEz Ver. 2.00" );
	cprintf( "\r\nCopyright (c) 1997, FAST Corporation. ALL rights reserved" );
	cprintf( "\r\n" );
#else
	printf( "\nRS232C Sample programyC_RCMDGS.EXEz Ver. 2.00" );
	printf( "\nCopyright (c) 1997, FAST Corporation. ALL rights reserved" );
	printf( "\n" );
#endif
	
	/* ftHgZbg */
	machine  = PC9801;
	speed    = B9600;
	length   = L8;
	parities = PNONE;
	stops    = S1;
	xs       = XCOFF;
	channel  = FIRST;
	
	/* R}hC */
	argv++;
	for( ; --argc > 0; argv++ )
	{
	    strupr( *argv );
	    if( **argv == '-' )
	    {
			switch( *( *argv + 1 ) )
			{
		    	case 'M':
					if( !( strcmp( *argv + 2, "0" ) ) )			machine = PC9801;
					else if( !( strcmp( *argv + 2, "1" ) ) )	machine = IBMPC;
					else if( !( strcmp( *argv + 2, "2" ) ) )	machine = J3100;
					else if( !( strcmp( *argv + 2, "3" ) ) )	machine = AX;
					else illegal_option();
					break;
				case 'B':
					if( !( strcmp( *argv + 2, "1200" ) ) )			speed = B1200;
					else if( !( strcmp( *argv + 2, "1800" ) ) )		speed = B2400;
					else if( !( strcmp( *argv + 2, "2400" ) ) )		speed = B2400;
					else if( !( strcmp( *argv + 2, "4800" ) ) )		speed = B4800;
					else if( !( strcmp( *argv + 2, "9600" ) ) )		speed = B9600;
					else if( !( strcmp( *argv + 2, "19200" ) ) )	speed = B19200;
					else illegal_option();
					break;
				case 'L':
					if( !( strcmp( *argv + 2, "5" ) ) )			length = L5;
					else if( !( strcmp( *argv + 2, "6" ) ) )	length = L6;
					else if( !( strcmp( *argv + 2, "7" ) ) )	length = L7;
					else if( !( strcmp( *argv + 2, "8" ) ) )	length = L8;
					else illegal_option();
					break;
				case 'P':
					if( !( strcmp( *argv + 2, "0" ) ) )			parities = PNONE;
					else if( !( strcmp( *argv + 2, "1" ) ) )	parities = PODD;
					else if( !( strcmp( *argv + 2, "3" ) ) )	parities = PEVEN;
					else illegal_option();
					break;
				case 'S':
					if( !( strcmp( *argv + 2, "0" ) ) )			stops = S1;
					else if( !( strcmp( *argv + 2, "1" ) ) )	stops = S15;
					else if( !( strcmp( *argv + 2, "3" ) ) )	stops = S2;
					else illegal_option();
					break;
				case '?':
					
#ifdef __WATCOMC__
					cprintf( "\r\nUsage:" );
					cprintf( "\r\n" );
					cprintf( "\r\n  c_rcmdgs [option [option...]]" );
					cprintf( "\r\n" );
					cprintf( "\r\noptions" );
					cprintf( "\r\n");
					cprintf( "\r\n  -Mn  Machine  n : 0(PC9801), 1(IBMPC), 2(J3100), 3(AX) (default : 0)" );
					cprintf( "\r\n  -Bn  Baudrete  n : 1200, 1800, 2400, 4800, 9600, 19200 (default : 9600)" );
					cprintf( "\r\n  -Ln  Data bit  n : 5, 6, 7, 8 (default : 8)" );
					cprintf( "\r\n  -Pn  Parity  n : 0(NONE), 1(ODD), 3(EVEN) (default : 0)" );
					cprintf( "\r\n  -Sn  Stop bit  n : 0(1bit), 1(1.5bit), 3(2bit) (default : 0)" );
					cprintf( "\r\n");
#else
					printf( "\nUsage:" );
					printf( "\n" );
					printf( "\n  c_rcmdgs [option [option...]]" );
					printf( "\n" );
					printf( "\noptions" );
					printf( "\n");
				    printf( "\n  -Mn  Machine  n : 0(PC9801), 1(IBMPC), 2(J3100), 3(AX) (default : 0)" );
				    printf( "\n  -Bn  Baudrete  n : 1200, 1800, 2400, 4800, 9600, 19200 (default : 9600)" );
				    printf( "\n  -Ln  Data bit  n : 5, 6, 7, 8 (default : 8)" );
				    printf( "\n  -Pn  Parity  n : 0(NONE), 1(ODD), 3(EVEN) (default : 0)" );
				    printf( "\n  -Sn  Stop bit  n : 0(1bit), 1(1.5bit), 3(2bit) (default : 0)" );
				    printf( "\n");
#endif
					
					exit( 0 );
			}
	    }
	}
	
	/* qrQRQb̏ */
	ret = init_rs232c( machine, speed, length, parities, stops, xs, channel );
	if( NO_ERROR == ret )
	{
		exit_value = 0;
		
		/* OCT[`s */
		ret = rs232c_gs_cmd();
		if( CR_OK == ret )
		{
			
#ifdef __WATCOMC__
			cprintf( "\r\n" );
#else
			printf( "\n" );
#endif
			
		}
		else
		{
			rs232c_err_message( ret );
			exit_value = 1;
		}
		
		/* qrQRQb̏I */
		finish_rs232c();
		exit( exit_value );
	}
	else
	{
		
#ifdef __WATCOMC__
		cprintf( "\r\nRS-232C Initialize error\r\n" );
#else
		printf( "\nRS-232C Initialize error\n" );
#endif
		
		exit( 1 );
	}
}


/*
 * OCT[`s
 */
static short	rs232c_gs_cmd()
{
	char			cmd_buff[10];		/* R}hobt@ */
	short			ret, ret_value;
	unsigned char	recv_buff[10];		/* Mobt@ */
	short			length, recv_cnt;
	short			copy_flag;
	unsigned char	recv_data[100];
	unsigned char	x_data[10];
	unsigned char	y_data[10];
	unsigned char	s_data[10];
	
	ret_value = CR_ERR;
	
	/* frR}h */
	strcpy( cmd_buff, "GS 0" );
	ret = outcmd_rs232c( cmd_buff );
	if( NO_ERROR == ret )
	{
		/* GR[obN̂ */
		gets_rs232c( WAITING, 6, recv_buff, &length, RETRY_TIME );
		
		copy_flag = ON;
		recv_data[0] = '\0';
		recv_cnt = 0;
		
		while( 1 )
		{
			/* f[^̎M */
			ret = gets_rs232c( WAITING, 1, recv_buff, &length, RETRY_TIME );
			if( NO_ERROR == ret )
			{
				if( '>' == recv_buff[0] )
				{	/* vvg */
					break;
				}
				else if( CMD_ACK == recv_buff[0] )
				{	/* I('!') */
					ret_value = CR_OK;
					copy_flag = OFF;
				}
				else if( CMD_NAK == recv_buff[0] )
				{	/* ُI('%') */
					ret_value = CR_NAK;
					copy_flag = OFF;
				}
				else if( CMD_NON == recv_buff[0] )
				{	/* R}h` */
					ret_value = CR_NON;
					copy_flag = OFF;
				}
				else
				{	/* f[^ */
					if( ON == copy_flag )
					{
						recv_data[recv_cnt] = recv_buff[0];
						recv_cnt++;
					}
				}
			}
		}
		
		if( CR_OK == ret_value )
		{
			recv_data[recv_cnt] = '\0';
			get_infdata( recv_data, x_data, y_data, s_data );
			sprintf( recv_data, "XPOS:%s, YPOS:%s, SCORE:%s\n", x_data, y_data, s_data );
			
#ifdef __WATCOMC__
			cprintf( "%s",recv_data );
#else
			printf( "%s",recv_data );
#endif
			
			rs232c_gs_next();
			
			/* dR}h */
			strcpy( cmd_buff, "E" );
			ret = outcmd_rs232c( cmd_buff );
			if( NO_ERROR == ret )
			{
				/* GR[obN̂ */
				gets_rs232c( WAITING, 3, recv_buff, &length, RETRY_TIME );
				
				/* R}h`FbN */
				ret = checkcmdack_rs232c( RETRY_TIME );
				if( NO_ERROR == ret )
				{
					/* brbXOPvvg`FbN */
					checkprmpt_rs232c( RETRY_TIME );
				}
				else	ret_value = CR_ERR;
			}
			else	ret_value = CR_ERR;
		}
	}
	
	return ret_value;
}


/*
 * p^擾
 */
static short rs232c_gs_next()
{
	char			cmd_buff[10];		/* R}hobt@ */
	short			ret, ret_value;
	unsigned char	recv_buff[10];		/* Mobt@ */
	short			process;
	short			length, recv_cnt;
	short			copy_flag;
	unsigned char	recv_data[100];
	unsigned char	x_data[10];
	unsigned char	y_data[10];
	unsigned char	s_data[10];
	
	ret_value = CR_ERR;
	
	for( process = ON; OFF != process; )
	{
		/* mR}h */
		strcpy( cmd_buff, "N" );
		ret = outcmd_rs232c( cmd_buff );
		if( NO_ERROR == ret )
		{
			/* GR[obN̂ */
			gets_rs232c( WAITING, 3, recv_buff, &length, RETRY_TIME );
			
			copy_flag = ON;
			recv_data[0] = '\0';
			recv_cnt = 0;
			
			while( 1 )
			{
				/* f[^̎M */
				ret = gets_rs232c( WAITING, 1, recv_buff, &length, RETRY_TIME );
				if( NO_ERROR == ret )
				{
					if( '>' == recv_buff[0] )
					{	/* vvg */
						break;
					}
					else if( CMD_ACK == recv_buff[0] )
					{	/* I('!') */
						ret_value = CR_OK;
						copy_flag = OFF;
					}
					else if( CMD_NAK == recv_buff[0] )
					{	/* ُI('%') */
						ret_value = CR_NAK;
						copy_flag = OFF;
						process = OFF;
					}
					else if( CMD_NON == recv_buff[0] )
					{	/* R}h` */
						ret_value = CR_NON;
						copy_flag = OFF;
						process = OFF;
					}
					else
					{	/* f[^ */
						if( ON == copy_flag )
						{
							recv_data[recv_cnt] = recv_buff[0];
							recv_cnt++;
						}
					}
				}
			}
		}
		
		if( CR_OK == ret_value )
		{
			recv_data[recv_cnt] = '\0';
			get_infdata( recv_data, x_data, y_data, s_data );
			sprintf( recv_data, "XPOS:%s, YPOS:%s, SCORE:%s\n", x_data, y_data, s_data );
			
#ifdef __WATCOMC__
			cprintf( "%s",recv_data );
#else
			printf( "%s",recv_data );
#endif
			
		}
	}
	
	return ret_value;
}


/*
 * Mf[^wWAxWA֒l擾
 */
static void	get_infdata( unsigned char data[], unsigned char x_data[], 
						 unsigned char y_data[], unsigned char s_data[] )
{
	int				len;
	short			i, j;
	int				part;
	
	x_data[0] = '\0';
	y_data[0] = '\0';
	s_data[0] = '\0';
	
	part = 0;
	len = strlen( (char *)data );
	for( i = 0, j = 0; i < len; i++ )
	{
		if( 0x20 == data[i] )	/* ' ' */
		{
			part++;
			j = 0;
		}
		else
		{
			switch( part )
			{
				case	0:		/* x_data */
					x_data[j] = data[i];
					x_data[j+1] = '\0';
					j++;
					break;
				case	1:		/* y_data */
					y_data[j] = data[i];
					y_data[j+1] = '\0';
					j++;
					break;
				case	2:		/* s_data */
					if( 0x0A != data[i] )	/* '\n' */
					{
						s_data[j] = data[i];
						s_data[j+1] = '\0';
						j++;
					}
					break;
				default:
					break;
			}
		}
	}
}


/*
 * ʂ̃NAƃt[
 */
static void	rs232c_clear_cmd()
{
	char			cmd_buff[10];		/* R}hobt@ */
	short			ret;
	unsigned char	recv_buff[10];		/* Mobt@ */
	short			length;
	
	/* bR}h */
	strcpy( cmd_buff, "C\n" );
	ret = puts_rs232c( cmd_buff, 2 );
	if( NO_ERROR == ret )
	{
		/* GR[obN̂ */
		gets_rs232c( WAITING, 2, recv_buff, &length, RETRY_TIME );
		
		/* R}h`FbN */
		ret = checkcmdack_rs232c( RETRY_TIME );
		if( NO_ERROR == ret )
		{
			/* brbXOPvvg`FbN */
			checkprmpt_rs232c( RETRY_TIME );
		}
	}
}


/*
 *	qrQRQbG[bZ[W̏o
 */
static void	rs232c_err_message( short err_code )
{
	
#ifdef __WATCOMC__
	cprintf( "\r\nRS232C Error " );
	switch( err_code )
	{
	    case CR_NAK:
			cprintf( "[GS]" );
			rs232c_clear_cmd();
			break;
	    case CR_NON:
			cprintf( "[COMMAND]" );
			break;
	    default:
			cprintf( "[??????????]" );
	}
	cprintf( "\r\n" );
#else
	printf( "\nRS232C Error " );
	switch( err_code )
	{
	    case CR_NAK:
			printf( "[GS]" );
			rs232c_clear_cmd();
			break;
	    case CR_NON:
			printf( "[COMMAND]" );
			break;
	    default:
			printf( "[??????????]" );
	}
	printf( "\n" );
#endif
	
}


/*
 *	R}hĈُƂ̓bZ[W\AvO
 *	I܂B
 */
static void illegal_option(void)
{
	
#ifdef __WATCOMC__
	cprintf( "\r\nInvalid options" );
#else
	printf( "\nInvalid options" );
#endif
	
	exit( 1 );
}

